#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <functional>
#include <set>
#include <sstream>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <iomanip>
#include <random>
#include <cassert>

using namespace std;

int i;

void gen_1_subtask(const char* file_name, int N = 0)
{
	while (N == 0)
		N = (int(rand()) * int(rand()) % 100000);

	if (N % 2 == 1)
		N++;

	int K = N / 2;
	freopen(file_name, "w", stdout);
	cout << N << ' ' << K << endl;

	if (rand() % 2)
	{
		for (int i = 1; i <= N; i += 2)
			cout << i << endl;
	}
	else
	{
		for (int i = 2; i <= N; i += 2)
			cout << i << endl;
	}
}


string normalize(string s)
{
	for (int i = 0; i < s.length(); i++)
		if (s[i] == s[i + 1] && s[i] == '1')
			s[i + 1] = '0';
	return s;
}

void gen_2_3_subtask(const char* file_name, int N = 0, int K = 0)
{
	string s;
	for (int i = 0; i <= N; i++)
		s += "0";

	freopen(file_name, "w", stdout);

	for (int i = 0; i < K; i++)
		s[int(rand()) * int(rand()) % N + 1] = '1';

	s = normalize(s);
	vector<int> v;
	for (int i = 1; i <= N; i++)
	{
		if (s[i] == '1')
			v.push_back(i);
	}

	cout << N << ' ' << v.size() << endl;
	for (int i = 0; i < v.size(); i++)
		cout << v[i] << endl;
}

string make_str(int i)
{
	stringstream ss;
	ss << i;
	string s;
	ss >> s;
	if (i < 10)
		s = "0" + s;
	s += ".in";
	return s;
}

void go1(int i, int N = 0)
{
	string s = make_str(i);
	const char *file_name = s.c_str();
	gen_1_subtask(file_name, N);
}

void go2(int i, int N = 0, int K = 0)
{
	string s = make_str(i);
	const char *file_name = s.c_str();
	gen_2_3_subtask(file_name, N, K);
}


int main()
{
	srand(222);
	for (int i = 4; i <= 15; i++)
		go1(i);

	go2(16, 1, 0);
	go2(17, 4, 1);
	go2(18, 5, 2);
	go2(19, 6, 3);
	go2(20, 8, 3);
	go2(21, 14, 3);
	go2(22, 15, 3);
	go2(23, 16, 5);
	go2(24, 17, 7);
	go2(25, 18, 7);
	go2(26, 19, 5);
	go2(27, 20, 0);

	go2(28, 100, 10);
	go2(29, 1000, 10);
	go2(30, 1000, 50);
	go2(31, 1000, 100);
	go2(32, 10000, 500);
	go2(33, 100000, 1000);
	go2(34, 100000, 50000);
	go2(35, 1000000, 0);
	go2(36, 1000000, 10);
	go2(37, 1000000, 1000);
	go2(38, 1000000, 1000);
	go2(39, 1000000, 100000);
	go2(40, 1000000, 100000);
}